Asynchronous Data allows charts to load data on demand, supporting progressive detail loading and server-side paging when used with Zoom or the Scrollbar.
Data Source Copy Link
Use the dataSource option to provide an asynchronous getData callback. The chart calls this function on initial load and then whenever the visible window changes, and displays a loading overlay until the returned promise resolves.
import {
AgCartesianChartOptions,
AgCharts,
AnimationModule,
ContextMenuModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NavigatorModule,
NumberAxisModule,
TimeAxisModule,
ZoomModule,
} from "ag-charts-enterprise";
import { Database } from "./data";
import { FakeServer } from "./fakeServer";
ModuleRegistry.registerModules([
AnimationModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
NavigatorModule,
NumberAxisModule,
TimeAxisModule,
ZoomModule,
ContextMenuModule,
]);
const options: AgCartesianChartOptions = {
dataSource: {
getData: ({ windowStart, windowEnd, source }) => {
// Request the data from your server; this asynchronous call may take up to 2500ms.
// The mini chart requests a coarse full-range overview, the main chart the visible window.
return source === "mini-chart"
? FakeServer.get({})
: FakeServer.get({ windowStart, windowEnd });
},
},
navigator: {
enabled: true,
miniChart: {},
},
zoom: {
enabled: true,
},
initialState: {
zoom: {
ratioX: { start: 0.7, end: 1 },
},
},
series: [
{
type: "line",
xKey: "time",
yKey: "price",
yName: "Price",
},
],
axes: {
y: {
type: "number",
min: 400,
max: 1600,
},
x: {
type: "time",
min: new Date("2019-01-01 00:00:00"),
max: new Date("2024-12-30 23:59:59"),
interval: {
minSpacing: 100,
maxSpacing: 200,
},
label: {
formatter: ({ value }) =>
Intl.DateTimeFormat("en-GB", {
day: "2-digit",
month: "short",
year: "2-digit",
}).format(new Date(value)),
},
},
},
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
// Refresh the underlying server data, then call updateDelta({}) to re-trigger getData for the
// current window. The chart shows its loading overlay while the new data is fetched.
function reload() {
Database.refresh();
chart.updateDelta({});
}
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).reload = reload;
}
import { createSeededRandom } from "./seededRandom";
/**
* This fake database generates and returns randomised data of objects with time, price and quantity. If you are a
* frontend developer you can safely ignore this part of the example.
*/
export const Database = {
get: () => (data ??= generate(seed)),
// Re-generate the dataset with a new seed so a reload returns a visibly different price series, mimicking
// fresh data arriving from a real server.
refresh: () => {
seed += 1;
data = generate(seed);
},
};
export const minute = 1000 * 60;
export const hour = minute * 60;
export const day = hour * 24;
export const week = day * 7;
export const month = day * 30;
export const dataStart = new Date("2019-01-01 00:00:00").getTime();
export const dataEnd = new Date("2024-12-30 23:59:59").getTime();
let data: Array<Datum> | undefined;
let seed = 1;
const center = 1000;
function generate(seed: number): Array<Datum> {
const random = createSeededRandom(seed);
const result: Array<Datum> = [];
for (let time = dataStart; time < dataEnd; time += hour) {
let price;
if (result.length === 0) {
price = center + random() * 100;
} else if (result.length < 5) {
price = result[result.length - 1].price + random() * 20 - 10;
} else {
const avg =
result.slice(result.length - 5).reduce((a, v) => a + v.price, 0) / 5;
// Mean-reverting random walk: a gentle pull back towards the centre keeps the series within the
// chart's fixed y-axis range for any seed, so each reload looks different without clipping.
price = avg + (random() * 50 - 25) + (center - avg) * 0.002;
}
result.push({ time, price });
}
return result;
}
export type Datum = { time: number; price: number };
import { Database, Datum, dataEnd, dataStart, day, hour, week } from "./data";
import { random } from "./seededRandom";
/**
* This fake server mimics how a real server api chart service may get and format data for charts. If you are a
* frontend developer you can safely ignore this part of the example.
*/
export const FakeServer = {
get: async function (params: {
windowStart?: Date | number | string;
windowEnd?: Date | number | string;
}) {
// Simulate a real server with a random 2000-2500ms delay
const delayTime = 2000 + Math.floor(random() * 500);
await delay(delayTime);
// Fetch the data from the fake database
const data = Database.get();
// Format the data ready for the chart
const formattedData = formatData(
data,
toTimestamp(params.windowStart) ?? dataStart,
toTimestamp(params.windowEnd) ?? dataEnd,
);
return formattedData;
},
};
function toTimestamp(
value: Date | number | string | undefined,
): number | undefined {
if (value === undefined) return undefined;
if (value instanceof Date) return value.getTime();
if (typeof value === "number") return value;
return new Date(value).getTime();
}
function delay(ms: number) {
return new Promise((resolve) => setTimeout(resolve, ms));
}
function formatData(data: Datum[], windowStart: number, windowEnd: number) {
const diff = windowEnd - windowStart;
let granularity = week * 4;
if (diff < week * 2) {
granularity = hour;
} else if (diff < week * 13) {
granularity = day;
} else if (diff < week * 52) {
granularity = week;
}
return data.filter(({ time }) => {
const isCoarse = (time - dataStart) % (week * 4) === 0;
const isFineWithinWindow =
(time - dataStart) % granularity === 0 &&
time >= windowStart &&
time <= windowEnd;
return isCoarse || isFineWithinWindow;
});
}
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
{
dataSource: {
getData: ({ windowStart, windowEnd }) => {
return FakeServer.get({ windowStart, windowEnd });
},
},
}In this example:
- The fake server returns coarse data covering the full date range alongside finer-grained data for the visible window.
- As the user zooms in,
getDatais re-invoked with updatedwindowStartandwindowEndvalues and the server returns higher-resolution data for that range.
The getData callback receives an AgDataSourceCallbackParams object with:
windowStart: the start of the visible window.windowEnd: the end of the visible window.source: what triggered the request, such as'mini-chart','user-interaction'or'chart-update'.context: the chart context object, if one has been provided.
The returned data must include the first and last data points so the chart can establish the axis domain, unless the axis has explicit min and max values.
When the Navigator Mini Chart is enabled, it issues its own getData call with source: 'mini-chart' to load a full-range overview, independent of the main chart's windowed fetches. This is only done on initial load or options update.
Triggering a Reload Copy Link
Calling updateDelta({}) with an empty object triggers getData to be called again, which is useful for refreshing data on demand. The Reload Data button in the example above does exactly this; the loading overlay is shown while the request is in progress, and the chart updates with the freshly fetched data once it resolves.
chart.updateDelta({}); Loading Overlay Copy Link
While getData is in progress, the chart displays a Loading Overlay automatically. The overlay can be customised through the overlays.loading option; see Overlays for text customisation and custom renderers.
Manual Control Copy Link
Set loading on the chart options to control the overlay independently of dataSource.
import {
AgChartOptions,
AgCharts,
AnimationModule,
ContextMenuModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
const datasets = [
[120, 145, 98, 160, 135],
[200, 175, 220, 190, 210],
[80, 95, 70, 110, 85],
[155, 130, 180, 145, 165],
];
let loadIndex = 0;
function getData() {
const values = datasets[loadIndex % datasets.length];
loadIndex++;
return values.map((spending, i) => ({ year: 2020 + i, spending }));
}
ModuleRegistry.registerModules([
AnimationModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const options: AgChartOptions = {
dataSource: {
getData: () =>
new Promise((resolve) => setTimeout(() => resolve(getData()), 2000)),
},
series: [
{
type: "line",
xKey: "year",
yKey: "spending",
},
],
axes: {
x: { type: "number", title: { text: "Year" } },
y: { type: "number", title: { text: "Spending" } },
},
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
function loadingChange(event: Event) {
const value = (event.target as HTMLInputElement).value;
chart.updateDelta({
loading: value === "undefined" ? undefined : value === "true",
});
}
function reload() {
chart.updateDelta({});
}
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).loadingChange = loadingChange;
(<any>window).reload = reload;
}
Use the buttons to override the loading state.
{
loading: true,
}true- force the overlay on.false- force the overlay off.undefined- automatic, shown whilegetDatais pending and hidden when it resolves.
API Reference Copy Link
Properties available on the AgDataSourceOptions interface.
- getData required
Function - Asynchronous callback to load data into the chart.
Properties available on the AgDataSourceOptions interface.
- getData required
Function - Asynchronous callback to load data into the chart.

Asynchronous Data allows charts to load data on demand, supporting progressive detail loading and server-side paging when used with Zoom or the Scrollbar.
Data Source Copy Link
Use the dataSource option to provide an asynchronous getData callback. The chart calls this function on initial load and then whenever the visible window changes, and displays a loading overlay until the returned promise resolves.
import { Component, ViewChild } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgCartesianChartOptions,
AnimationModule,
ContextMenuModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NavigatorModule,
NumberAxisModule,
TimeAxisModule,
ZoomModule,
} from "ag-charts-enterprise";
import { Database } from "./data";
import { FakeServer } from "./fakeServer";
import clone from "clone";
ModuleRegistry.registerModules([
AnimationModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
NavigatorModule,
NumberAxisModule,
TimeAxisModule,
ZoomModule,
ContextMenuModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<div class="example-controls">
<div class="controls-row">
<button (click)="reload()">Reload Data</button>
</div>
</div>
<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
@ViewChild(AgCharts)
public agCharts!: AgCharts;
constructor() {
this.options = {
dataSource: {
getData: ({ windowStart, windowEnd, source }) => {
// Request the data from your server; this asynchronous call may take up to 2500ms.
// The mini this.agCharts.chart! requests a coarse full-range overview, the main this.agCharts.chart! the visible window.
return source === "mini-chart"
? FakeServer.get({})
: FakeServer.get({ windowStart, windowEnd });
},
},
navigator: {
enabled: true,
miniChart: {},
},
zoom: {
enabled: true,
},
initialState: {
zoom: {
ratioX: { start: 0.7, end: 1 },
},
},
series: [
{
type: "line",
xKey: "time",
yKey: "price",
yName: "Price",
},
],
axes: {
y: {
type: "number",
min: 400,
max: 1600,
},
x: {
type: "time",
min: new Date("2019-01-01 00:00:00"),
max: new Date("2024-12-30 23:59:59"),
interval: {
minSpacing: 100,
maxSpacing: 200,
},
label: {
formatter: ({ value }) =>
Intl.DateTimeFormat("en-GB", {
day: "2-digit",
month: "short",
year: "2-digit",
}).format(new Date(value)),
},
},
},
};
}
// Refresh the underlying server data, then call updateDelta({}) to re-trigger getData for the
// current window. The this.agCharts.chart! shows its loading overlay while the new data is fetched.
reload = () => {
Database.refresh();
this.agCharts.chart!.updateDelta({});
};
}
import { createSeededRandom } from "./seededRandom";
/**
* This fake database generates and returns randomised data of objects with time, price and quantity. If you are a
* frontend developer you can safely ignore this part of the example.
*/
export const Database = {
get: () => (data ??= generate(seed)),
// Re-generate the dataset with a new seed so a reload returns a visibly different price series, mimicking
// fresh data arriving from a real server.
refresh: () => {
seed += 1;
data = generate(seed);
},
};
export const minute = 1000 * 60;
export const hour = minute * 60;
export const day = hour * 24;
export const week = day * 7;
export const month = day * 30;
export const dataStart = new Date("2019-01-01 00:00:00").getTime();
export const dataEnd = new Date("2024-12-30 23:59:59").getTime();
let data: Array<Datum> | undefined;
let seed = 1;
const center = 1000;
function generate(seed: number): Array<Datum> {
const random = createSeededRandom(seed);
const result: Array<Datum> = [];
for (let time = dataStart; time < dataEnd; time += hour) {
let price;
if (result.length === 0) {
price = center + random() * 100;
} else if (result.length < 5) {
price = result[result.length - 1].price + random() * 20 - 10;
} else {
const avg =
result.slice(result.length - 5).reduce((a, v) => a + v.price, 0) / 5;
// Mean-reverting random walk: a gentle pull back towards the centre keeps the series within the
// chart's fixed y-axis range for any seed, so each reload looks different without clipping.
price = avg + (random() * 50 - 25) + (center - avg) * 0.002;
}
result.push({ time, price });
}
return result;
}
export type Datum = { time: number; price: number };
import { Database, Datum, dataEnd, dataStart, day, hour, week } from "./data";
import { random } from "./seededRandom";
/**
* This fake server mimics how a real server api chart service may get and format data for charts. If you are a
* frontend developer you can safely ignore this part of the example.
*/
export const FakeServer = {
get: async function (params: {
windowStart?: Date | number | string;
windowEnd?: Date | number | string;
}) {
// Simulate a real server with a random 2000-2500ms delay
const delayTime = 2000 + Math.floor(random() * 500);
await delay(delayTime);
// Fetch the data from the fake database
const data = Database.get();
// Format the data ready for the chart
const formattedData = formatData(
data,
toTimestamp(params.windowStart) ?? dataStart,
toTimestamp(params.windowEnd) ?? dataEnd,
);
return formattedData;
},
};
function toTimestamp(
value: Date | number | string | undefined,
): number | undefined {
if (value === undefined) return undefined;
if (value instanceof Date) return value.getTime();
if (typeof value === "number") return value;
return new Date(value).getTime();
}
function delay(ms: number) {
return new Promise((resolve) => setTimeout(resolve, ms));
}
function formatData(data: Datum[], windowStart: number, windowEnd: number) {
const diff = windowEnd - windowStart;
let granularity = week * 4;
if (diff < week * 2) {
granularity = hour;
} else if (diff < week * 13) {
granularity = day;
} else if (diff < week * 52) {
granularity = week;
}
return data.filter(({ time }) => {
const isCoarse = (time - dataStart) % (week * 4) === 0;
const isFineWithinWindow =
(time - dataStart) % granularity === 0 &&
time >= windowStart &&
time <= windowEnd;
return isCoarse || isFineWithinWindow;
});
}
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
{
dataSource: {
getData: ({ windowStart, windowEnd }) => {
return FakeServer.get({ windowStart, windowEnd });
},
},
}In this example:
- The fake server returns coarse data covering the full date range alongside finer-grained data for the visible window.
- As the user zooms in,
getDatais re-invoked with updatedwindowStartandwindowEndvalues and the server returns higher-resolution data for that range.
The getData callback receives an AgDataSourceCallbackParams object with:
windowStart: the start of the visible window.windowEnd: the end of the visible window.source: what triggered the request, such as'mini-chart','user-interaction'or'chart-update'.context: the chart context object, if one has been provided.
The returned data must include the first and last data points so the chart can establish the axis domain, unless the axis has explicit min and max values.
When the Navigator Mini Chart is enabled, it issues its own getData call with source: 'mini-chart' to load a full-range overview, independent of the main chart's windowed fetches. This is only done on initial load or options update.
Triggering a Reload Copy Link
Calling updateDelta({}) with an empty object triggers getData to be called again, which is useful for refreshing data on demand. The Reload Data button in the example above does exactly this; the loading overlay is shown while the request is in progress, and the chart updates with the freshly fetched data once it resolves.
chart.updateDelta({}); Loading Overlay Copy Link
While getData is in progress, the chart displays a Loading Overlay automatically. The overlay can be customised through the overlays.loading option; see Overlays for text customisation and custom renderers.
Manual Control Copy Link
Set loading on the chart options to control the overlay independently of dataSource.
import { Component, ViewChild } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
AnimationModule,
ContextMenuModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import clone from "clone";
const datasets = [
[120, 145, 98, 160, 135],
[200, 175, 220, 190, 210],
[80, 95, 70, 110, 85],
[155, 130, 180, 145, 165],
];
let loadIndex = 0;
function getData() {
const values = datasets[loadIndex % datasets.length];
loadIndex++;
return values.map((spending, i) => ({ year: 2020 + i, spending }));
}
ModuleRegistry.registerModules([
AnimationModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<div class="example-controls">
<div class="controls-row">
Loading:
<div class="button-group gap-right" role="group" aria-label="Loading">
<input type="radio" id="loading-true" name="loading-state" value="true" (change)="loadingChange($event)">
<label for="loading-true"><code>true</code></label>
<input type="radio" id="loading-false" name="loading-state" value="false" (change)="loadingChange($event)">
<label for="loading-false"><code>false</code></label>
<input type="radio" id="loading-undefined" name="loading-state" value="undefined" checked="" (change)="loadingChange($event)">
<label for="loading-undefined"><code>undefined</code></label>
</div>
<button (click)="reload()">Reload</button>
</div>
</div>
<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
@ViewChild(AgCharts)
public agCharts!: AgCharts;
constructor() {
this.options = {
dataSource: {
getData: () =>
new Promise((resolve) => setTimeout(() => resolve(getData()), 2000)),
},
series: [
{
type: "line",
xKey: "year",
yKey: "spending",
},
],
axes: {
x: { type: "number", title: { text: "Year" } },
y: { type: "number", title: { text: "Spending" } },
},
};
}
loadingChange = (event: Event) => {
const value = (event.target as HTMLInputElement).value;
this.agCharts.chart!.updateDelta({
loading: value === "undefined" ? undefined : value === "true",
});
};
reload = () => {
this.agCharts.chart!.updateDelta({});
};
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
Use the buttons to override the loading state.
{
loading: true,
}true- force the overlay on.false- force the overlay off.undefined- automatic, shown whilegetDatais pending and hidden when it resolves.
API Reference Copy Link
Properties available on the AgDataSourceOptions interface.
- getData required
Function - Asynchronous callback to load data into the chart.
Properties available on the AgDataSourceOptions interface.
- getData required
Function - Asynchronous callback to load data into the chart.

Asynchronous Data allows charts to load data on demand, supporting progressive detail loading and server-side paging when used with Zoom or the Scrollbar.
Data Source Copy Link
Use the dataSource option to provide an asynchronous getData callback. The chart calls this function on initial load and then whenever the visible window changes, and displays a loading overlay until the returned promise resolves.
import React, { useState, useRef, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgCartesianChartOptions,
AgChartsInstance,
AnimationModule,
ContextMenuModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NavigatorModule,
NumberAxisModule,
TimeAxisModule,
ZoomModule,
} from "ag-charts-enterprise";
import { Database } from "./data";
import { FakeServer } from "./fakeServer";
import clone from "clone";
ModuleRegistry.registerModules([
AnimationModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
NavigatorModule,
NumberAxisModule,
TimeAxisModule,
ZoomModule,
ContextMenuModule,
]);
const ChartExample = () => {
const chartRef = useRef<AgChartsInstance>(null);
const [options, setOptions] = useState<AgCartesianChartOptions>({
dataSource: {
getData: ({ windowStart, windowEnd, source }) => {
// Request the data from your server; this asynchronous call may take up to 2500ms.
// The mini chartRef.current! requests a coarse full-range overview, the main chartRef.current! the visible window.
return source === "mini-chart"
? FakeServer.get({})
: FakeServer.get({ windowStart, windowEnd });
},
},
navigator: {
enabled: true,
miniChart: {},
},
zoom: {
enabled: true,
},
initialState: {
zoom: {
ratioX: { start: 0.7, end: 1 },
},
},
series: [
{
type: "line",
xKey: "time",
yKey: "price",
yName: "Price",
},
],
axes: {
y: {
type: "number",
min: 400,
max: 1600,
},
x: {
type: "time",
min: new Date("2019-01-01 00:00:00"),
max: new Date("2024-12-30 23:59:59"),
interval: {
minSpacing: 100,
maxSpacing: 200,
},
label: {
formatter: ({ value }) =>
Intl.DateTimeFormat("en-GB", {
day: "2-digit",
month: "short",
year: "2-digit",
}).format(new Date(value)),
},
},
},
});
// Refresh the underlying server data, then call updateDelta({}) to re-trigger getData for the
// current window. The chartRef.current! shows its loading overlay while the new data is fetched.
const reload = () => {
Database.refresh();
chartRef.current!.updateDelta({});
};
return (
<Fragment>
<div className="example-controls">
<div className="controls-row">
<button onClick={reload}>Reload Data</button>
</div>
</div>
<AgCharts ref={chartRef} options={options} />
</Fragment>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
import { createSeededRandom } from "./seededRandom";
/**
* This fake database generates and returns randomised data of objects with time, price and quantity. If you are a
* frontend developer you can safely ignore this part of the example.
*/
export const Database = {
get: () => (data ??= generate(seed)),
// Re-generate the dataset with a new seed so a reload returns a visibly different price series, mimicking
// fresh data arriving from a real server.
refresh: () => {
seed += 1;
data = generate(seed);
},
};
export const minute = 1000 * 60;
export const hour = minute * 60;
export const day = hour * 24;
export const week = day * 7;
export const month = day * 30;
export const dataStart = new Date("2019-01-01 00:00:00").getTime();
export const dataEnd = new Date("2024-12-30 23:59:59").getTime();
let data: Array<Datum> | undefined;
let seed = 1;
const center = 1000;
function generate(seed: number): Array<Datum> {
const random = createSeededRandom(seed);
const result: Array<Datum> = [];
for (let time = dataStart; time < dataEnd; time += hour) {
let price;
if (result.length === 0) {
price = center + random() * 100;
} else if (result.length < 5) {
price = result[result.length - 1].price + random() * 20 - 10;
} else {
const avg =
result.slice(result.length - 5).reduce((a, v) => a + v.price, 0) / 5;
// Mean-reverting random walk: a gentle pull back towards the centre keeps the series within the
// chart's fixed y-axis range for any seed, so each reload looks different without clipping.
price = avg + (random() * 50 - 25) + (center - avg) * 0.002;
}
result.push({ time, price });
}
return result;
}
export type Datum = { time: number; price: number };
import { Database, Datum, dataEnd, dataStart, day, hour, week } from "./data";
import { random } from "./seededRandom";
/**
* This fake server mimics how a real server api chart service may get and format data for charts. If you are a
* frontend developer you can safely ignore this part of the example.
*/
export const FakeServer = {
get: async function (params: {
windowStart?: Date | number | string;
windowEnd?: Date | number | string;
}) {
// Simulate a real server with a random 2000-2500ms delay
const delayTime = 2000 + Math.floor(random() * 500);
await delay(delayTime);
// Fetch the data from the fake database
const data = Database.get();
// Format the data ready for the chart
const formattedData = formatData(
data,
toTimestamp(params.windowStart) ?? dataStart,
toTimestamp(params.windowEnd) ?? dataEnd,
);
return formattedData;
},
};
function toTimestamp(
value: Date | number | string | undefined,
): number | undefined {
if (value === undefined) return undefined;
if (value instanceof Date) return value.getTime();
if (typeof value === "number") return value;
return new Date(value).getTime();
}
function delay(ms: number) {
return new Promise((resolve) => setTimeout(resolve, ms));
}
function formatData(data: Datum[], windowStart: number, windowEnd: number) {
const diff = windowEnd - windowStart;
let granularity = week * 4;
if (diff < week * 2) {
granularity = hour;
} else if (diff < week * 13) {
granularity = day;
} else if (diff < week * 52) {
granularity = week;
}
return data.filter(({ time }) => {
const isCoarse = (time - dataStart) % (week * 4) === 0;
const isFineWithinWindow =
(time - dataStart) % granularity === 0 &&
time >= windowStart &&
time <= windowEnd;
return isCoarse || isFineWithinWindow;
});
}
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
{
dataSource: {
getData: ({ windowStart, windowEnd }) => {
return FakeServer.get({ windowStart, windowEnd });
},
},
}In this example:
- The fake server returns coarse data covering the full date range alongside finer-grained data for the visible window.
- As the user zooms in,
getDatais re-invoked with updatedwindowStartandwindowEndvalues and the server returns higher-resolution data for that range.
The getData callback receives an AgDataSourceCallbackParams object with:
windowStart: the start of the visible window.windowEnd: the end of the visible window.source: what triggered the request, such as'mini-chart','user-interaction'or'chart-update'.context: the chart context object, if one has been provided.
The returned data must include the first and last data points so the chart can establish the axis domain, unless the axis has explicit min and max values.
When the Navigator Mini Chart is enabled, it issues its own getData call with source: 'mini-chart' to load a full-range overview, independent of the main chart's windowed fetches. This is only done on initial load or options update.
Triggering a Reload Copy Link
Calling updateDelta({}) with an empty object triggers getData to be called again, which is useful for refreshing data on demand. The Reload Data button in the example above does exactly this; the loading overlay is shown while the request is in progress, and the chart updates with the freshly fetched data once it resolves.
chart.updateDelta({}); Loading Overlay Copy Link
While getData is in progress, the chart displays a Loading Overlay automatically. The overlay can be customised through the overlays.loading option; see Overlays for text customisation and custom renderers.
Manual Control Copy Link
Set loading on the chart options to control the overlay independently of dataSource.
import React, { useState, useRef, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AgChartsInstance,
AnimationModule,
ContextMenuModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import clone from "clone";
const datasets = [
[120, 145, 98, 160, 135],
[200, 175, 220, 190, 210],
[80, 95, 70, 110, 85],
[155, 130, 180, 145, 165],
];
let loadIndex = 0;
function getData() {
const values = datasets[loadIndex % datasets.length];
loadIndex++;
return values.map((spending, i) => ({ year: 2020 + i, spending }));
}
ModuleRegistry.registerModules([
AnimationModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const ChartExample = () => {
const chartRef = useRef<AgChartsInstance>(null);
const [options, setOptions] = useState<AgChartOptions>({
dataSource: {
getData: () =>
new Promise((resolve) => setTimeout(() => resolve(getData()), 2000)),
},
series: [
{
type: "line",
xKey: "year",
yKey: "spending",
},
],
axes: {
x: { type: "number", title: { text: "Year" } },
y: { type: "number", title: { text: "Spending" } },
},
});
const loadingChange = (event: Event) => {
const value = (event.target as HTMLInputElement).value;
chartRef.current!.updateDelta({
loading: value === "undefined" ? undefined : value === "true",
});
};
const reload = () => {
chartRef.current!.updateDelta({});
};
return (
<Fragment>
<div className="example-controls">
<div className="controls-row">
Loading:
<div
className="button-group gap-right"
role="group"
aria-label="Loading"
>
<input
type="radio"
id="loading-true"
name="loading-state"
defaultValue="true"
onChange={(event) => loadingChange(event)}
/>
<label htmlFor="loading-true">
<code>true</code>
</label>
<input
type="radio"
id="loading-false"
name="loading-state"
defaultValue="false"
onChange={(event) => loadingChange(event)}
/>
<label htmlFor="loading-false">
<code>false</code>
</label>
<input
type="radio"
id="loading-undefined"
name="loading-state"
defaultValue="undefined"
defaultChecked
onChange={(event) => loadingChange(event)}
/>
<label htmlFor="loading-undefined">
<code>undefined</code>
</label>
</div>
<button onClick={reload}>Reload</button>
</div>
</div>
<AgCharts ref={chartRef} options={options} />
</Fragment>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
Use the buttons to override the loading state.
{
loading: true,
}true- force the overlay on.false- force the overlay off.undefined- automatic, shown whilegetDatais pending and hidden when it resolves.
API Reference Copy Link
Properties available on the AgDataSourceOptions interface.
- getData required
Function - Asynchronous callback to load data into the chart.
Properties available on the AgDataSourceOptions interface.
- getData required
Function - Asynchronous callback to load data into the chart.

Asynchronous Data allows charts to load data on demand, supporting progressive detail loading and server-side paging when used with Zoom or the Scrollbar.
Data Source Copy Link
Use the dataSource option to provide an asynchronous getData callback. The chart calls this function on initial load and then whenever the visible window changes, and displays a loading overlay until the returned promise resolves.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
AnimationModule,
ContextMenuModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NavigatorModule,
NumberAxisModule,
TimeAxisModule,
ZoomModule,
} from "ag-charts-enterprise";
import { Database } from "./data";
import { FakeServer } from "./fakeServer";
import clone from "clone";
ModuleRegistry.registerModules([
AnimationModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
NavigatorModule,
NumberAxisModule,
TimeAxisModule,
ZoomModule,
ContextMenuModule,
]);
const ChartExample = defineComponent({
template: `
<div class="example-controls">
<div class="controls-row">
<button v-on:click="reload()">Reload Data</button>
</div>
</div>
<ag-charts
ref="agCharts"
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgCartesianChartOptions>({
dataSource: {
getData: ({ windowStart, windowEnd, source }) => {
// Request the data from your server; this asynchronous call may take up to 2500ms.
// The mini agCharts.value.chart requests a coarse full-range overview, the main agCharts.value.chart the visible window.
return source === "mini-chart"
? FakeServer.get({})
: FakeServer.get({ windowStart, windowEnd });
},
},
navigator: {
enabled: true,
miniChart: {},
},
zoom: {
enabled: true,
},
initialState: {
zoom: {
ratioX: { start: 0.7, end: 1 },
},
},
series: [
{
type: "line",
xKey: "time",
yKey: "price",
yName: "Price",
},
],
axes: {
y: {
type: "number",
min: 400,
max: 1600,
},
x: {
type: "time",
min: new Date("2019-01-01 00:00:00"),
max: new Date("2024-12-30 23:59:59"),
interval: {
minSpacing: 100,
maxSpacing: 200,
},
label: {
formatter: ({ value }) =>
Intl.DateTimeFormat("en-GB", {
day: "2-digit",
month: "short",
year: "2-digit",
}).format(new Date(value)),
},
},
},
});
const agCharts = ref(null);
// Refresh the underlying server data, then call updateDelta({}) to re-trigger getData for the
// current window. The agCharts.value.chart shows its loading overlay while the new data is fetched.
const reload = () => {
Database.refresh();
agCharts.value.chart.updateDelta({});
};
return {
options,
agCharts,
reload,
};
},
});
createApp(ChartExample).mount("#app");
import { createSeededRandom } from "./seededRandom";
/**
* This fake database generates and returns randomised data of objects with time, price and quantity. If you are a
* frontend developer you can safely ignore this part of the example.
*/
export const Database = {
get: () => (data ??= generate(seed)),
// Re-generate the dataset with a new seed so a reload returns a visibly different price series, mimicking
// fresh data arriving from a real server.
refresh: () => {
seed += 1;
data = generate(seed);
},
};
export const minute = 1000 * 60;
export const hour = minute * 60;
export const day = hour * 24;
export const week = day * 7;
export const month = day * 30;
export const dataStart = new Date("2019-01-01 00:00:00").getTime();
export const dataEnd = new Date("2024-12-30 23:59:59").getTime();
let data: Array<Datum> | undefined;
let seed = 1;
const center = 1000;
function generate(seed: number): Array<Datum> {
const random = createSeededRandom(seed);
const result: Array<Datum> = [];
for (let time = dataStart; time < dataEnd; time += hour) {
let price;
if (result.length === 0) {
price = center + random() * 100;
} else if (result.length < 5) {
price = result[result.length - 1].price + random() * 20 - 10;
} else {
const avg =
result.slice(result.length - 5).reduce((a, v) => a + v.price, 0) / 5;
// Mean-reverting random walk: a gentle pull back towards the centre keeps the series within the
// chart's fixed y-axis range for any seed, so each reload looks different without clipping.
price = avg + (random() * 50 - 25) + (center - avg) * 0.002;
}
result.push({ time, price });
}
return result;
}
export type Datum = { time: number; price: number };
import { Database, Datum, dataEnd, dataStart, day, hour, week } from "./data";
import { random } from "./seededRandom";
/**
* This fake server mimics how a real server api chart service may get and format data for charts. If you are a
* frontend developer you can safely ignore this part of the example.
*/
export const FakeServer = {
get: async function (params: {
windowStart?: Date | number | string;
windowEnd?: Date | number | string;
}) {
// Simulate a real server with a random 2000-2500ms delay
const delayTime = 2000 + Math.floor(random() * 500);
await delay(delayTime);
// Fetch the data from the fake database
const data = Database.get();
// Format the data ready for the chart
const formattedData = formatData(
data,
toTimestamp(params.windowStart) ?? dataStart,
toTimestamp(params.windowEnd) ?? dataEnd,
);
return formattedData;
},
};
function toTimestamp(
value: Date | number | string | undefined,
): number | undefined {
if (value === undefined) return undefined;
if (value instanceof Date) return value.getTime();
if (typeof value === "number") return value;
return new Date(value).getTime();
}
function delay(ms: number) {
return new Promise((resolve) => setTimeout(resolve, ms));
}
function formatData(data: Datum[], windowStart: number, windowEnd: number) {
const diff = windowEnd - windowStart;
let granularity = week * 4;
if (diff < week * 2) {
granularity = hour;
} else if (diff < week * 13) {
granularity = day;
} else if (diff < week * 52) {
granularity = week;
}
return data.filter(({ time }) => {
const isCoarse = (time - dataStart) % (week * 4) === 0;
const isFineWithinWindow =
(time - dataStart) % granularity === 0 &&
time >= windowStart &&
time <= windowEnd;
return isCoarse || isFineWithinWindow;
});
}
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
{
dataSource: {
getData: ({ windowStart, windowEnd }) => {
return FakeServer.get({ windowStart, windowEnd });
},
},
}In this example:
- The fake server returns coarse data covering the full date range alongside finer-grained data for the visible window.
- As the user zooms in,
getDatais re-invoked with updatedwindowStartandwindowEndvalues and the server returns higher-resolution data for that range.
The getData callback receives an AgDataSourceCallbackParams object with:
windowStart: the start of the visible window.windowEnd: the end of the visible window.source: what triggered the request, such as'mini-chart','user-interaction'or'chart-update'.context: the chart context object, if one has been provided.
The returned data must include the first and last data points so the chart can establish the axis domain, unless the axis has explicit min and max values.
When the Navigator Mini Chart is enabled, it issues its own getData call with source: 'mini-chart' to load a full-range overview, independent of the main chart's windowed fetches. This is only done on initial load or options update.
Triggering a Reload Copy Link
Calling updateDelta({}) with an empty object triggers getData to be called again, which is useful for refreshing data on demand. The Reload Data button in the example above does exactly this; the loading overlay is shown while the request is in progress, and the chart updates with the freshly fetched data once it resolves.
chart.updateDelta({}); Loading Overlay Copy Link
While getData is in progress, the chart displays a Loading Overlay automatically. The overlay can be customised through the overlays.loading option; see Overlays for text customisation and custom renderers.
Manual Control Copy Link
Set loading on the chart options to control the overlay independently of dataSource.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
AnimationModule,
ContextMenuModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import clone from "clone";
const datasets = [
[120, 145, 98, 160, 135],
[200, 175, 220, 190, 210],
[80, 95, 70, 110, 85],
[155, 130, 180, 145, 165],
];
let loadIndex = 0;
function getData() {
const values = datasets[loadIndex % datasets.length];
loadIndex++;
return values.map((spending, i) => ({ year: 2020 + i, spending }));
}
ModuleRegistry.registerModules([
AnimationModule,
CrosshairModule,
DataSourceModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const ChartExample = defineComponent({
template: `
<div class="example-controls">
<div class="controls-row">
Loading:
<div class="button-group gap-right" role="group" aria-label="Loading">
<input type="radio" id="loading-true" name="loading-state" value="true" v-on:change="loadingChange($event)">
<label for="loading-true"><code>true</code></label>
<input type="radio" id="loading-false" name="loading-state" value="false" v-on:change="loadingChange($event)">
<label for="loading-false"><code>false</code></label>
<input type="radio" id="loading-undefined" name="loading-state" value="undefined" checked="" v-on:change="loadingChange($event)">
<label for="loading-undefined"><code>undefined</code></label>
</div>
<button v-on:click="reload()">Reload</button>
</div>
</div>
<ag-charts
ref="agCharts"
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
dataSource: {
getData: () =>
new Promise((resolve) => setTimeout(() => resolve(getData()), 2000)),
},
series: [
{
type: "line",
xKey: "year",
yKey: "spending",
},
],
axes: {
x: { type: "number", title: { text: "Year" } },
y: { type: "number", title: { text: "Spending" } },
},
});
const agCharts = ref(null);
const loadingChange = (event) => {
const value = event.target.value;
agCharts.value.chart.updateDelta({
loading: value === "undefined" ? undefined : value === "true",
});
};
const reload = () => {
agCharts.value.chart.updateDelta({});
};
return {
options,
agCharts,
loadingChange,
reload,
};
},
});
createApp(ChartExample).mount("#app");
Use the buttons to override the loading state.
{
loading: true,
}true- force the overlay on.false- force the overlay off.undefined- automatic, shown whilegetDatais pending and hidden when it resolves.
API Reference Copy Link
Properties available on the AgDataSourceOptions interface.
- getData required
Function - Asynchronous callback to load data into the chart.
Properties available on the AgDataSourceOptions interface.
- getData required
Function - Asynchronous callback to load data into the chart.